commit b1eae3d9848aa0f035b3e6564294d1b98fcb9c1c
Author: jklowden <jklowden>
Date:   Wed Nov 12 00:47:25 2008 +0000

    dbsqlok did not process entire packet Cf. ML today from Ted Hayes

diff --git a/ChangeLog b/ChangeLog
index 6ac17f8..fac72d5 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,14 @@
+Tue Nov 11 19:42:30 EST 2008	JK Lowden <jklowden@freetds.org>
+	* include/dblib.h src/dblib/dblib.c 
+	- dbsqlok did not process entire packet
+	- Cf. ML today from Ted Hayes
+	* src/dblib/unittests/t0005.c cosmetic changes
+	* src/tds/Makefile.am remember to build types.h
+	* src/ctlib/unittests/Makefile.am src/dblib/unittests/Makefile.am
+	* src/odbc/unittests/Makefile.am 
+	* src/tds/unittests/Makefile.am
+	- set RPATH to prefer build tree
+
 Tue Nov 11 09:39:05 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/error.c: fix test for newer Sybase
 
@@ -924,4 +935,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2658 2008/11/11 08:40:17 freddy77 Exp $
+$Id: ChangeLog,v 1.2659 2008/11/12 00:47:25 jklowden Exp $
diff --git a/include/dblib.h b/include/dblib.h
index d625ded..eb72b99 100644
--- a/include/dblib.h
+++ b/include/dblib.h
@@ -32,16 +32,16 @@ extern "C"
 #endif
 #endif
 
-/* $Id: dblib.h,v 1.43 2007/12/05 03:04:11 jklowden Exp $ */
-
-enum {
-	  _DB_RES_INIT            = 0
-	, _DB_RES_RESULTSET_EMPTY = 1
-	, _DB_RES_RESULTSET_ROWS  = 2
-	, _DB_RES_NEXT_RESULT     = 3
-	, _DB_RES_NO_MORE_RESULTS = 4
-	, _DB_RES_SUCCEED         = 5
-};
+/* $Id: dblib.h,v 1.44 2008/11/12 00:47:25 jklowden Exp $ */
+
+typedef enum tag_DB_RESULT_STATE {
+	  _DB_RES_INIT
+	, _DB_RES_RESULTSET_EMPTY
+	, _DB_RES_RESULTSET_ROWS
+	, _DB_RES_NEXT_RESULT
+	, _DB_RES_NO_MORE_RESULTS
+	, _DB_RES_SUCCEED
+} DB_RESULT_STATE;
 
 struct tds_dblib_loginrec
 {
@@ -147,7 +147,7 @@ struct tds_dblib_dbprocess
 
 	int noautofree;
 	int more_results;	/* boolean.  Are we expecting results? */
-	int dbresults_state;
+	DB_RESULT_STATE dbresults_state;
 	int dbresults_retcode;
 	BYTE *user_data;	/* see dbsetuserdata() and dbgetuserdata() */
 	unsigned char *dbbuf;	/* is dynamic!                   */
diff --git a/src/dblib/dblib.c b/src/dblib/dblib.c
index e485a29..1f86a15 100644
--- a/src/dblib/dblib.c
+++ b/src/dblib/dblib.c
@@ -76,7 +76,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: dblib.c,v 1.329 2008/08/18 13:31:27 freddy77 Exp $");
+TDS_RCSID(var, "$Id: dblib.c,v 1.330 2008/11/12 00:47:25 jklowden Exp $");
 
 static RETCODE _dbresults(DBPROCESS * dbproc);
 static int _db_get_server_type(int bindtype);
@@ -1608,7 +1608,6 @@ _dbresults(DBPROCESS * dbproc)
 	tdsdump_log(TDS_DBG_FUNC, "dbresults: dbresults_state is %d (%s)\n", 
 					dbproc->dbresults_state, prdbresults_state(dbproc->dbresults_state));
 	switch ( dbproc->dbresults_state ) {
-
 	case _DB_RES_SUCCEED:
 		dbproc->dbresults_state = _DB_RES_NEXT_RESULT;
 		return SUCCEED;
@@ -1698,6 +1697,9 @@ _dbresults(DBPROCESS * dbproc)
 					dbproc->dbresults_state = _DB_RES_NEXT_RESULT;
 					return SUCCEED;
 					break;
+				case _DB_RES_NO_MORE_RESULTS:
+				case _DB_RES_SUCCEED:
+					break;
 				}
 				break;
 
@@ -3734,7 +3736,6 @@ dbprhead(DBPROCESS * dbproc)
 RETCODE
 dbrows(DBPROCESS * dbproc)
 {
-	TDSRESULTINFO *resinfo;
 	TDSSOCKET *tds;
 
 	tdsdump_log(TDS_DBG_FUNC, "dbrows(%p)\n", dbproc);
@@ -3744,12 +3745,7 @@ dbrows(DBPROCESS * dbproc)
 	if (!(tds=dbproc->tds_socket))
 		return FAIL;
 
-	resinfo = tds->res_info;
-
-	if (resinfo && resinfo->rows_exist)
-		return SUCCEED;
-	else
-		return FAIL;
+	return (tds->res_info && tds->res_info->rows_exist)? SUCCEED : FAIL;
 }
 
 /**
@@ -4553,6 +4549,7 @@ dbsqlok(DBPROCESS * dbproc)
 	 * We're looking for a result token or a done token.
          */
 	while (!done) {
+		int retcode;
 		marker = tds_peek(tds);
 
 		/* If we hit a result token, then we know everything is OK.  */
@@ -4590,6 +4587,7 @@ dbsqlok(DBPROCESS * dbproc)
 				break;
 			case TDS_DONE_RESULT:
 			case TDS_DONEPROC_RESULT:
+#if 0
 				if (done_flags & TDS_DONE_ERROR) {
 					tdsdump_log(TDS_DBG_FUNC, "dbsqlok() end status was error\n");
 
@@ -4608,6 +4606,15 @@ dbsqlok(DBPROCESS * dbproc)
 					return SUCCEED;
 				}
 				break;
+#else
+				retcode = (done_flags & TDS_DONE_ERROR)? FAIL : SUCCEED;
+				dbproc->dbresults_state = (done_flags & TDS_DONE_MORE_RESULTS)?
+					_DB_RES_NEXT_RESULT : _DB_RES_NO_MORE_RESULTS;
+
+				tdsdump_log(TDS_DBG_FUNC, "dbsqlok: returning %s with %s (%#x)\n", 
+						prdbretcode(retcode), prdbresults_state(dbproc->dbresults_state), done_flags);
+				return retcode;
+#endif
 			default:
 				break;
 			}

